---
title: llarp::layers::flow::Deprecated_SNodeEndpoint
summary: shim for endpointbase on snode. 

---

# llarp::layers::flow::Deprecated_SNodeEndpoint



shim for endpointbase on snode. 


`#include <deprecated_flow_layer_pimpl.hpp>`

Inherits from [llarp::EndpointBase](Classes/classllarp_1_1EndpointBase.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| virtual bool | **[LookupRC](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-lookuprc)**([RouterID](Classes/structllarp_1_1RouterID.md) remote, RouterLookupHandler handler) override |

## Additional inherited members

**Public Classes inherited from [llarp::EndpointBase](Classes/classllarp_1_1EndpointBase.md)**

|                | Name           |
| -------------- | -------------- |
| struct | **[QUICMappingInfo](Classes/structllarp_1_1EndpointBase_1_1QUICMappingInfo.md)** <br>info about a quic mapping  |
| struct | **[SendStat](Classes/structllarp_1_1EndpointBase_1_1SendStat.md)**  |

**Public Types inherited from [llarp::EndpointBase](Classes/classllarp_1_1EndpointBase.md)**

|                | Name           |
| -------------- | -------------- |
| using std::variant< [service::Address](Classes/structllarp_1_1service_1_1Address.md), [RouterID](Classes/structllarp_1_1RouterID.md) > | **[AddressVariant_t](Classes/classllarp_1_1EndpointBase.md#using-addressvariant-t)**  |

**Public Functions inherited from [llarp::EndpointBase](Classes/classllarp_1_1EndpointBase.md)**

|                | Name           |
| -------------- | -------------- |
| virtual | **[~EndpointBase](Classes/classllarp_1_1EndpointBase.md#function-~endpointbase)**() =default |
| std::optional< [QUICMappingInfo](Classes/structllarp_1_1EndpointBase_1_1QUICMappingInfo.md) > | **[GetQUICMappingInfoByID](Classes/classllarp_1_1EndpointBase.md#function-getquicmappinginfobyid)**(int stream_id) const<br>maybe get quic mapping info given its stream id returns std::nullopt if we have no stream given that id  |
| void | **[PutSRVRecord](Classes/classllarp_1_1EndpointBase.md#function-putsrvrecord)**([dns::SRVData](Classes/structllarp_1_1dns_1_1SRVData.md) srv)<br>add an srv record to this endpoint's descriptor  |
| virtual std::shared_ptr< [dns::Server](Classes/classllarp_1_1dns_1_1Server.md) > | **[DNS](Classes/classllarp_1_1EndpointBase.md#function-dns)**() const<br>get dns serverr if we have on on this endpoint  |
| virtual void | **[SRVRecordsChanged](Classes/classllarp_1_1EndpointBase.md#function-srvrecordschanged)**() =0<br>called when srv data changes in some way  |
| bool | **[DelSRVRecordIf](Classes/classllarp_1_1EndpointBase.md#function-delsrvrecordif)**(std::function< bool(const [dns::SRVData](Classes/structllarp_1_1dns_1_1SRVData.md) &)> filter)<br>remove srv records from this endpoint that match a filter for each srv record call it with filter, remove if filter returns true return if we removed any srv records  |
| std::set< [dns::SRVData](Classes/structllarp_1_1dns_1_1SRVData.md) > | **[SRVRecords](Classes/classllarp_1_1EndpointBase.md#function-srvrecords)**() const<br>get copy of all srv records  |
| virtual std::optional< [SendStat](Classes/structllarp_1_1EndpointBase_1_1SendStat.md) > | **[GetStatFor](Classes/classllarp_1_1EndpointBase.md#function-getstatfor)**(AddressVariant_t remote) const =0<br>get statistics about how much traffic we sent and recv'd to a remote endpoint  |
| virtual std::unordered_set< AddressVariant_t > | **[AllRemoteEndpoints](Classes/classllarp_1_1EndpointBase.md#function-allremoteendpoints)**() const =0<br>list all remote endpoint addresses we have that are mapped  |
| virtual AddressVariant_t | **[LocalAddress](Classes/classllarp_1_1EndpointBase.md#function-localaddress)**() const =0<br>get our local address  |
| virtual [quic::TunnelManager](Classes/classllarp_1_1quic_1_1TunnelManager.md) * | **[GetQUICTunnel](Classes/classllarp_1_1EndpointBase.md#function-getquictunnel)**() =0 |
| virtual std::optional< AddressVariant_t > | **[GetEndpointWithConvoTag](Classes/classllarp_1_1EndpointBase.md#function-getendpointwithconvotag)**([service::ConvoTag](Classes/structllarp_1_1service_1_1ConvoTag.md) tag) const =0 |
| virtual std::optional< [service::ConvoTag](Classes/structllarp_1_1service_1_1ConvoTag.md) > | **[GetBestConvoTagFor](Classes/classllarp_1_1EndpointBase.md#function-getbestconvotagfor)**(AddressVariant_t addr) const =0 |
| virtual bool | **[EnsurePathTo](Classes/classllarp_1_1EndpointBase.md#function-ensurepathto)**(AddressVariant_t addr, std::function< void(std::optional< [service::ConvoTag](Classes/structllarp_1_1service_1_1ConvoTag.md) >)> hook, llarp_time_t timeout) =0<br>MUST call MarkAddressOutbound first if we are initiating the flow to the remote.  |
| virtual void | **[LookupNameAsync](Classes/classllarp_1_1EndpointBase.md#function-lookupnameasync)**(std::string name, std::function< void(std::optional< AddressVariant_t >)> resultHandler) =0 |
| virtual const EventLoop_ptr & | **[Loop](Classes/classllarp_1_1EndpointBase.md#function-loop)**() =0 |
| virtual bool | **[SendToOrQueue](Classes/classllarp_1_1EndpointBase.md#function-sendtoorqueue)**([service::ConvoTag](Classes/structllarp_1_1service_1_1ConvoTag.md) tag, const [llarp_buffer_t](Classes/structllarp__buffer__t.md) & payload, service::ProtocolType t) =0 |
| virtual void | **[LookupServiceAsync](Classes/classllarp_1_1EndpointBase.md#function-lookupserviceasync)**(std::string name, std::string service, std::function< void(std::vector< [dns::SRVData](Classes/structllarp_1_1dns_1_1SRVData.md) >)> resultHandler) =0<br>lookup srv records async  |
| virtual void | **[MarkAddressOutbound](Classes/classllarp_1_1EndpointBase.md#function-markaddressoutbound)**(AddressVariant_t remote) =0<br>will mark a remote as something we want to initiate a flow to.  |
| virtual bool | **[Configure](Classes/classllarp_1_1EndpointBase.md#function-configure)**(const [NetworkConfig](Classes/structllarp_1_1NetworkConfig.md) & , const [DnsConfig](Classes/structllarp_1_1DnsConfig.md) & ) =0 |
| virtual std::string_view | **[endpoint_name](Classes/classllarp_1_1EndpointBase.md#function-endpoint-name)**() const =0 |
| virtual void | **[start_endpoint](Classes/classllarp_1_1EndpointBase.md#function-start-endpoint)**() |
| virtual void | **[stop_endpoint](Classes/classllarp_1_1EndpointBase.md#function-stop-endpoint)**() |
| virtual void | **[periodic_tick](Classes/classllarp_1_1EndpointBase.md#function-periodic-tick)**() |


## Public Functions Documentation

### function LookupRC

```cpp
inline virtual bool LookupRC(
    RouterID remote,
    RouterLookupHandler handler
) override
```


**Reimplements**: [llarp::EndpointBase::LookupRC](Classes/classllarp_1_1EndpointBase.md#function-lookuprc)


-------------------------------

Updated on 2023-02-15 at 18:35:09 +0000