---
title: llarp::layers::platform::PlatformDriver
summary: base type that is responsible for bridging the os and the flow layer. 

---

# llarp::layers::platform::PlatformDriver



base type that is responsible for bridging the os and the flow layer.  [More...](#detailed-description)


`#include <platform_driver.hpp>`

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[PlatformDriver](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#function-platformdriver)**(const [PlatformDriver](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md) & ) =delete |
| | **[PlatformDriver](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#function-platformdriver)**([PlatformDriver](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md) && ) =delete |
| | **[PlatformDriver](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#function-platformdriver)**([PlatformDriver_pimpl](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md) * impl, [flow::FlowLayer](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md) & flow_layer, const [NetworkConfig](Classes/structllarp_1_1NetworkConfig.md) & netconf, const [DnsConfig](Classes/structllarp_1_1DnsConfig.md) & dnsconf) |
| void | **[start](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#function-start)**() |
| void | **[stop](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#function-stop)**() |
| virtual void | **[got_os_traffic](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#function-got-os-traffic)**(std::vector< [OSTraffic](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md) > pkts)<br>called each time we get a bunch of os traffic.  |
| void | **[map_remote](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#function-map-remote)**(std::string name, std::string auth, std::vector< [IPRange](Classes/structllarp_1_1IPRange.md) > ranges, bool is_exit, std::function< void(std::optional< [flow::FlowInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md) >, std::string)> result_handler) |
| void | **[map_exit](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#function-map-exit)**(std::string name, std::string auth, std::vector< [IPRange](Classes/structllarp_1_1IPRange.md) > ranges, std::function< void(bool, std::string)> result_handler)<br>calls map_remote() for exits  |
| const [AddrMapper](Classes/classllarp_1_1layers_1_1platform_1_1AddrMapper.md) & | **[addr_mapper](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#function-addr-mapper)**() const |
| void | **[unmap_exit](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#function-unmap-exit)**(std::string name, std::optional< [IPRange](Classes/structllarp_1_1IPRange.md) > range =std::nullopt)<br>unmap an exit from a range  |
| void | **[unmap_all_exits_on_range](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#function-unmap-all-exits-on-range)**([IPRange](Classes/structllarp_1_1IPRange.md) range)<br>unmap every exit that is mapped to this range.  |
| [PlatformStats](Classes/structllarp_1_1layers_1_1platform_1_1PlatformStats.md) | **[current_stats](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#function-current-stats)**() const |

## Protected Functions

|                | Name           |
| -------------- | -------------- |
| void | **[on_io](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#function-on-io)**()<br>called once per event loop tick after platform layer event loop polled for and consumed io.  |

## Protected Attributes

|                | Name           |
| -------------- | -------------- |
| const std::shared_ptr< [PlatformDriver_pimpl](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md) > | **[_impl](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#variable--impl)**  |
| [flow::FlowLayer](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md) & | **[_flow_layer](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#variable--flow-layer)**  |
| std::shared_ptr< [EventLoopWakeup](Classes/classllarp_1_1EventLoopWakeup.md) > | **[_os_send](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#variable--os-send)** <br>called to wake up the loop after we sent things out on the network  |
| std::shared_ptr< [EventLoopWakeup](Classes/classllarp_1_1EventLoopWakeup.md) > | **[_os_recv](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#variable--os-recv)** <br>called to wake up the loop to read os traffic  |
| [NetworkConfig](Classes/structllarp_1_1NetworkConfig.md) | **[_netconf](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#variable--netconf)**  |
| [AddrMapper](Classes/classllarp_1_1layers_1_1platform_1_1AddrMapper.md) | **[_addr_mapper](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#variable--addr-mapper)**  |
| [NameCache](Classes/classllarp_1_1layers_1_1platform_1_1NameCache.md) | **[_name_cache](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#variable--name-cache)**  |
| [NameResolver](Classes/classllarp_1_1layers_1_1platform_1_1NameResolver.md) | **[_name_resolver](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#variable--name-resolver)**  |
| std::shared_ptr< [llarp::dns::Server](Classes/classllarp_1_1dns_1_1Server.md) > | **[_dns_server](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#variable--dns-server)**  |
| [OSTraffic_IO_Base](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md) | **[_io](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#variable--io)**  |

## Friends

|                | Name           |
| -------------- | -------------- |
| struct | **[platform_io_wakeup_handler](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md#friend-platform-io-wakeup-handler)**  |

## Detailed Description

```cpp
class llarp::layers::platform::PlatformDriver;
```

base type that is responsible for bridging the os and the flow layer. 

each kind of ethertype has its own implementation. 

## Public Functions Documentation

### function PlatformDriver

```cpp
PlatformDriver(
    const PlatformDriver & 
) =delete
```


### function PlatformDriver

```cpp
PlatformDriver(
    PlatformDriver && 
) =delete
```


### function PlatformDriver

```cpp
PlatformDriver(
    PlatformDriver_pimpl * impl,
    flow::FlowLayer & flow_layer,
    const NetworkConfig & netconf,
    const DnsConfig & dnsconf
)
```


### function start

```cpp
void start()
```


### function stop

```cpp
void stop()
```


### function got_os_traffic

```cpp
virtual void got_os_traffic(
    std::vector< OSTraffic > pkts
)
```

called each time we get a bunch of os traffic. 

overrided by each kind of platform 


### function map_remote

```cpp
void map_remote(
    std::string name,
    std::string auth,
    std::vector< IPRange > ranges,
    bool is_exit,
    std::function< void(std::optional< flow::FlowInfo >, std::string)> result_handler
)
```


### function map_exit

```cpp
void map_exit(
    std::string name,
    std::string auth,
    std::vector< IPRange > ranges,
    std::function< void(bool, std::string)> result_handler
)
```

calls map_remote() for exits 

### function addr_mapper

```cpp
const AddrMapper & addr_mapper() const
```


### function unmap_exit

```cpp
void unmap_exit(
    std::string name,
    std::optional< IPRange > range =std::nullopt
)
```

unmap an exit from a range 

### function unmap_all_exits_on_range

```cpp
void unmap_all_exits_on_range(
    IPRange range
)
```

unmap every exit that is mapped to this range. 

### function current_stats

```cpp
PlatformStats current_stats() const
```


## Protected Functions Documentation

### function on_io

```cpp
void on_io()
```

called once per event loop tick after platform layer event loop polled for and consumed io. 

## Protected Attributes Documentation

### variable _impl

```cpp
const std::shared_ptr< PlatformDriver_pimpl > _impl;
```


### variable _flow_layer

```cpp
flow::FlowLayer & _flow_layer;
```


### variable _os_send

```cpp
std::shared_ptr< EventLoopWakeup > _os_send;
```

called to wake up the loop after we sent things out on the network 

### variable _os_recv

```cpp
std::shared_ptr< EventLoopWakeup > _os_recv;
```

called to wake up the loop to read os traffic 

### variable _netconf

```cpp
NetworkConfig _netconf;
```


### variable _addr_mapper

```cpp
AddrMapper _addr_mapper;
```


### variable _name_cache

```cpp
NameCache _name_cache;
```


### variable _name_resolver

```cpp
NameResolver _name_resolver;
```


### variable _dns_server

```cpp
std::shared_ptr< llarp::dns::Server > _dns_server;
```


### variable _io

```cpp
OSTraffic_IO_Base _io;
```


## Friends

### friend platform_io_wakeup_handler

```cpp
friend struct platform_io_wakeup_handler(
    platform_io_wakeup_handler 
);
```


-------------------------------

Updated on 2023-02-15 at 18:35:09 +0000