---
title: llarp::layers::route::RouteLayer

---

# llarp::layers::route::RouteLayer





## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[RouteLayer](Classes/classllarp_1_1layers_1_1route_1_1RouteLayer.md#function-routelayer)**([AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) & ) |
| std::optional< [Destination](Classes/classllarp_1_1layers_1_1route_1_1Destination.md) > | **[destination_for](Classes/classllarp_1_1layers_1_1route_1_1RouteLayer.md#function-destination-for)**(const [path::TransitHopInfo](Classes/structllarp_1_1path_1_1TransitHopInfo.md) & info) const<br>maybe fetch a routing destination that was previously created for an endpoint transit hop.  |
| std::optional< [Destination](Classes/classllarp_1_1layers_1_1route_1_1Destination.md) > | **[create_local_destination](Classes/classllarp_1_1layers_1_1route_1_1RouteLayer.md#function-create-local-destination)**(const [path::TransitHopInfo](Classes/structllarp_1_1path_1_1TransitHopInfo.md) & info, [PubKey](Classes/structllarp_1_1PubKey.md) them, bool is_exit)<br>create a local destination belonging to pubkey+endpoint transithop.  |
| bool | **[remove_destination](Classes/classllarp_1_1layers_1_1route_1_1RouteLayer.md#function-remove-destination)**(const [path::TransitHopInfo](Classes/structllarp_1_1path_1_1TransitHopInfo.md) & info)<br>remove a routing destination for an existing endpoint transit hop.  |
| std::optional< [Destination](Classes/classllarp_1_1layers_1_1route_1_1Destination.md) > | **[destination_to](Classes/classllarp_1_1layers_1_1route_1_1RouteLayer.md#function-destination-to)**(const [PathID_t](Classes/structllarp_1_1PathID__t.md) & pathid)<br>get a routing destination given a local path id.  |

## Public Functions Documentation

### function RouteLayer

```cpp
explicit RouteLayer(
    AbstractRouter & 
)
```


### function destination_for

```cpp
std::optional< Destination > destination_for(
    const path::TransitHopInfo & info
) const
```

maybe fetch a routing destination that was previously created for an endpoint transit hop. 

### function create_local_destination

```cpp
std::optional< Destination > create_local_destination(
    const path::TransitHopInfo & info,
    PubKey them,
    bool is_exit
)
```

create a local destination belonging to pubkey+endpoint transithop. 

### function remove_destination

```cpp
bool remove_destination(
    const path::TransitHopInfo & info
)
```

remove a routing destination for an existing endpoint transit hop. 

### function destination_to

```cpp
std::optional< Destination > destination_to(
    const PathID_t & pathid
)
```

get a routing destination given a local path id. 

-------------------------------

Updated on 2023-02-15 at 18:35:09 +0000