---
title: llarp/layers/flow/deprecated_flow_layer_pimpl.hpp

---

# llarp/layers/flow/deprecated_flow_layer_pimpl.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::flow](Namespaces/namespacellarp_1_1layers_1_1flow.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::layers::flow::Deprecated_SNodeEndpoint](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md)** <br>shim for endpointbase on snode.  |
| struct | **[llarp::layers::flow::DeprecatedPimpl](Classes/structllarp_1_1layers_1_1flow_1_1DeprecatedPimpl.md)** <br>this holds all deprecated types, moved from the old deprecated kitchen sink.  |




## Source code

```cpp
#pragma once
#include "flow_layer.hpp"
#include <llarp/router_contact.hpp>
#include <llarp/service/endpoint.hpp>
#include <llarp/util/logging.hpp>
#include <llarp/router/abstractrouter.hpp>
#include <llarp/dht/context.hpp>

#include <memory>
#include <stdexcept>

namespace llarp::layers::flow
{
  auto logcat = llarp::log::Cat("layer:flow:deprecated");

  class Deprecated_SNodeEndpoint : public llarp::EndpointBase
  {
    AbstractRouter& _router;

   public:
    bool
    LookupRC(RouterID remote, RouterLookupHandler handler) override
    {
      return _router.dht()->impl->LookupRouter(remote, handler);
    }
  };

  struct DeprecatedPimpl
  {
    AbstractRouter& _router;
    std::shared_ptr<llarp::EndpointBase> endpoint;

    explicit DeprecatedPimpl(AbstractRouter& router) : _router{router}
    {
      if (router.IsServiceNode())
      {
        endpoint = std::make_shared<Deprecated_SNodeEndpoint>(_router);
      }
      else
      {
        endpoint = std::make_shared<llarp::service::Endpoint>(_router);
      }
      std::weak_ptr weak{endpoint};

      // set up end of event loop pump
      _router.loop()->add_ticker([weak]() {
        if (auto ptr = weak.lock())
        {
          log::trace(logcat, "pump '{}'"_format(ptr->endpoint_name()));
          ptr->event_loop_pump();
        }
      });

      // call periodic tick function.
      // this was done before in service::Context and exit::Context (i think)
      _router.loop()->call_every(100ms, weak, [weak]() {
        if (auto ptr = weak.lock())
        {
          log::trace(logcat, "tick '{}'"_format(ptr->endpoint_name()));
          ptr->periodic_tick();
        }
      });

      log::info(logcat, "configuring...");
      auto config = _router.GetConfig();
      if (not endpoint->Configure(config->network, config->dns))
        throw std::runtime_error{"ep->Configure(netconf, dnsconf) returned false"};

      log::info(logcat, "set up '{}'"_format(endpoint->endpoint_name()));
    }

    void
    start()
    {
      endpoint->start_endpoint();
    }

    void
    stop()
    {
      endpoint->stop_endpoint();
    }
  };
}  // namespace llarp::layers::flow
```


-------------------------------

Updated on 2023-02-15 at 18:35:10 +0000
