---
title: llarp/layers/route/route_layer.hpp

---

# llarp/layers/route/route_layer.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::route](Namespaces/namespacellarp_1_1layers_1_1route.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::layers::route::RouteLayer](Classes/classllarp_1_1layers_1_1route_1_1RouteLayer.md)**  |




## Source code

```cpp
#pragma once

#include <llarp/path/transit_hop.hpp>
#include <llarp/crypto/types.hpp>
#include "destination.hpp"

namespace llarp
{
  struct AbstractRouter;
}

namespace llarp::layers::route
{

  class RouteLayer
  {
   public:
    explicit RouteLayer(AbstractRouter&);

    std::optional<Destination>
    destination_for(const path::TransitHopInfo& info) const;

    std::optional<Destination>
    create_local_destination(const path::TransitHopInfo& info, PubKey them, bool is_exit);

    bool
    remove_destination(const path::TransitHopInfo& info);

    std::optional<Destination>
    destination_to(const PathID_t& pathid);
  };
}  // namespace llarp::layers::route
```


-------------------------------

Updated on 2023-02-15 at 18:35:10 +0000
